#include <IRremote.hpp>
#include "pitches.h"
#define IR_RECEIVE_PIN 7
#include <TimerFreeTone.h>
#define TONE_PIN 8

const int DOOR_SENSOR_PIN = 13;



// notes in the melody:
int melody[] = {
  NOTE_C4, NOTE_G3, NOTE_G3, NOTE_A3, NOTE_G3, 0, NOTE_B3, NOTE_C4
};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  4, 8, 8, 4, 4, 4, 4, 4
};

int melody2[] = { 262, 196, 196, 220, 196, 0, 247, 262 };
int duration[] = { 250, 125, 125, 250, 250, 250, 250, 250 };

int currentDoorState; // current state of door sensor
int lastDoorState;    // previous state of door sensor

void setup()
{

  Serial.begin(115200); // // Establish serial communication
  IrReceiver.begin(IR_RECEIVE_PIN, ENABLE_LED_FEEDBACK); // Start the receiver
  pinMode(DOOR_SENSOR_PIN, INPUT_PULLUP);

  currentDoorState = digitalRead(DOOR_SENSOR_PIN); // read state
}
int lastCmd;
unsigned long lastTime;

void loop() {

  handleDoor();

  if (IrReceiver.decode()) {
      // Serial.println(IrReceiver.decodedIRData.decodedRawData, HEX); // Print "old" raw data
      // IrReceiver.printIRResultShort(&Serial); // Print complete received data in one line
      // IrReceiver.printIRSendUsage(&Serial);   // Print the statement required to send this data
      // if(lastCmd == IrReceiver.decodedIRData.command && lastTime + 2000 > millis() )
      // {
      //   IrReceiver.resume();
      //   return;
      // }
      switch(IrReceiver.decodedIRData.command)
      {
        case 67:
          Serial.println("Play");
          playTone();
          break;
        default:
          Serial.print("unk: ");
          Serial.println(IrReceiver.decodedIRData.command);
      }
      
      //IrReceiver.printIRResultShort(&Serial); // Print complete received data in one line
      // lastTime = millis();
      // lastCmd=IrReceiver.decodedIRData.command;
      //Serial.println(IrReceiver.decodedIRData.command);

      IrReceiver.resume();
  }
  
}

void handleDoor(){
  lastDoorState = currentDoorState;              // save the last state
  currentDoorState  = digitalRead(DOOR_SENSOR_PIN); // read new state

  if (lastDoorState == LOW && currentDoorState == HIGH) { // state change: LOW -> HIGH
    Serial.println("The door-opening event is detected");
    playTone();
  }
  else
  if (lastDoorState == HIGH && currentDoorState == LOW) { // state change: HIGH -> LOW
    Serial.println("The door-closing event is detected");
    // TODO: turn off alarm, light or send notification ...
  }
}

void playTone(){
  // // iterate over the notes of the melody:
  // for (int thisNote = 0; thisNote < 8; thisNote++) {

  //   // to calculate the note duration, take one second divided by the note type.
  //   //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
  //   int noteDuration = 1000 / noteDurations[thisNote];
  //   tone(8, melody[thisNote], noteDuration);

  //   // to distinguish the notes, set a minimum time between them.
  //   // the note's duration + 30% seems to work well:
  //   int pauseBetweenNotes = noteDuration * 1.30;
  //   delay(pauseBetweenNotes);
  //   // stop the tone playing:
  //   noTone(8);
  // }

  for (int thisNote = 0; thisNote < 8; thisNote++) { // Loop through the notes in the array.
    TimerFreeTone(TONE_PIN, melody2[thisNote], duration[thisNote]); // Play thisNote for duration.
    delay(50); // Short delay between notes.
  }
}


